# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2023-08-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, validator

class AuthorizeOrderRequest(BaseModel):
    """
    Request to capture or void transaction
    """
    action: Optional[StrictStr] = Field(None, description="Type of authorization to run. Can be one of 'CAPTURE' , 'VOID'")
    amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The amount if you are running a 'CAPTURE'")
    __properties = ["action", "amount"]

    @validator('action')
    def action_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('CAPTURE', 'VOID'):
            raise ValueError("must be one of enum values ('CAPTURE', 'VOID')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AuthorizeOrderRequest:
        """Create an instance of AuthorizeOrderRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> AuthorizeOrderRequest:
        """Create an instance of AuthorizeOrderRequest from a JSON string"""
        temp_dict = json.loads(json_str)
        if "action, amount" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AuthorizeOrderRequest:
        """Create an instance of AuthorizeOrderRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AuthorizeOrderRequest.parse_obj(obj)

        _obj = AuthorizeOrderRequest.parse_obj({
            "action": obj.get("action"),
            "amount": obj.get("amount")
        })
        return _obj


