# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2023-08-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist

class ESOrderReconRequestFilters(BaseModel):
    """
    Provide the filter object details.
    """
    start_date: Optional[StrictStr] = Field(None, description="Specify the start data from which you want to get the recon data.")
    end_date: Optional[StrictStr] = Field(None, description="Specify the end data till which you want to get the recon data.")
    order_ids: Optional[conlist(StrictStr)] = Field(None, description="Please provide list of order ids for which you want to get the recon data.")
    __properties = ["start_date", "end_date", "order_ids"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ESOrderReconRequestFilters:
        """Create an instance of ESOrderReconRequestFilters from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> ESOrderReconRequestFilters:
        """Create an instance of ESOrderReconRequestFilters from a JSON string"""
        temp_dict = json.loads(json_str)
        if "start_date, end_date, order_ids" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ESOrderReconRequestFilters:
        """Create an instance of ESOrderReconRequestFilters from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ESOrderReconRequestFilters.parse_obj(obj)

        _obj = ESOrderReconRequestFilters.parse_obj({
            "start_date": obj.get("start_date"),
            "end_date": obj.get("end_date"),
            "order_ids": obj.get("order_ids")
        })
        return _obj


